#pragma semicolon 1
#include <sourcemod>
#include <sdktools>


public Plugin:myinfo =
{
	name = "Monster Extension Core",
	author = "ZombieX2",
	description = "Monster Extension Core",
	version = "0.0.0.1 beta",
	url = "http://www.ZombieX2.net"
};

/*
Monster Extension use custom tier1.lib
https://bugs.alliedmods.net/show_bug.cgi?id=4946

FireBulletsInfo_t 
	int m_iDamage; to float m_iDamage;

*/

public OnPluginStart( )
{
	PrintToServer("****************************************************");
	PrintToServer("           Monster Extension Core LOADED");
	PrintToServer("                   By ZombieX2.net");
	PrintToServer("****************************************************");
}

public OnMapStart()
{
	PrecacheModel("models/headcrabclassic.mdl",true);
	PrecacheModel("models/headcrab.mdl",true);
	PrecacheModel("models/headcrabblack.mdl",true);

	PrecacheModel("models/zombie/classic.mdl",true);
	PrecacheModel("models/zombie/classic_torso.mdl",true);
	PrecacheModel("models/zombie/classic_legs.mdl",true);
	PrecacheModel("models/zombie/fast.mdl",true);
	PrecacheModel("models/zombie/Fast_torso.mdl",true);
	PrecacheModel("models/gibs/fast_zombie_torso.mdl",true);
	PrecacheModel("models/gibs/fast_zombie_legs.mdl",true);
	PrecacheModel("models/zombie/poison.mdl",true);
	
	PrecacheModel("models/manhack.mdl",true);
	
	PrecacheModel("models/antlion.mdl",true);
	PrecacheModel("models/antlion_worker.mdl",true);
	PrecacheModel("models/antlion_guard.mdl",true);
	
	PrecacheModel("models/stalker.mdl",true);
	
	PrecacheModel("models/vortigaunt.mdl",true);

	PrecacheModel("models/roller.mdl",true);
	PrecacheModel("models/roller_spikes.mdl",true);

	PrecacheModel("sprites/grubflare1.vmt",true);
	PrecacheModel("sprites/glow1.vmt",true);
	PrecacheModel("sprites/laser.vmt",true);
	PrecacheModel("sprites/redglow1.vmt",true);
	PrecacheModel("sprites/orangeglow1.vmt",true);
	PrecacheModel("sprites/yellowglow1.vmt",true);
	PrecacheModel("sprites/lgtning.vmt",true);
	PrecacheModel("sprites/vortring1.vmt",true);
	
	PrecacheModel("sprites/bluelight1.vmt",true);
	PrecacheModel("sprites/rollermine_shock.vmt",true);
	PrecacheModel("sprites/rollermine_shock_yellow.vmt",true);
	
	PrecacheModel("models/props_combine/headcrabcannister01a.mdl",true);
	PrecacheModel("models/props_combine/headcrabcannister01b.mdl",true);
	PrecacheModel("models/props_combine/headcrabcannister01a_skybox.mdl",true);

	ReadDownloadFile();
}


public ReadDownloadFile()
{
	new String:sPath[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, sPath, sizeof(sPath),"configs/monster_download.txt");
	
	new Handle:file = OpenFile(sPath, "rb");
	if(file == INVALID_HANDLE)
		return;
	
	new String:readData[256];
	new length;
	while(!IsEndOfFile(file) && ReadFileLine(file, readData, sizeof(readData)))
	{
		TrimString(readData);
		if(!FileExists(readData))
		{
			PrintToServer("%s Not Exist!",readData);
			continue;
		}
		length = strlen(readData);
		if(length >= 4)
		{
			if(StrEqual(readData[length-4],".mdl") && !IsModelPrecached(readData))
			{
				PrecacheModel(readData,true);
			}
		}
		AddFileToDownloadsTable(readData);
	}
	CloseHandle(file);
}





/**
 * Do not edit below this line!
 */
public Extension:__ext_monster = 
{
	name = "Monster",
	file = "monster.ext",
#if defined AUTOLOAD_EXTENSIONS
	autoload = 1,
#else
	autoload = 0,
#endif
#if defined REQUIRE_EXTENSIONS
	required = 1,
#else
	required = 0,
#endif
};
